Subject: Re: [spring] A question for draft-fz-spring-srv6-alt-mark

From: Tianran Zhou <[email-masked]>
Date: Thu, 11 Nov 2021 06:48:14 +0000

Hi Tom,

Please see my reply below.

Best,
Tianran

-----邮件原件-----
发件人: Tom Herbert [mailto:[email-masked]] 
发送时间: 2021年11月11日 2:32
收件人: Tianran Zhou <[email-masked]>
抄送: Joel M. Halpern <[email-masked]>; [email-masked]; [email-masked]; [email-masked]
主题: Re: [spring] A question for draft-fz-spring-srv6-alt-mark

On Tue, Nov 9, 2021 at 7:41 PM Tianran Zhou <[email-masked]> wrote:
>
> Hi Joel,
>
> I do not need to assume a device that support SRH will support this new TLV.
> We only assume the device that do not support this new TLV can ignore and bypass the packet, not to drop.
> I see text from RFC8754 section 2.1.
> " all TLVs are ignored unless local configuration indicates otherwise "
> " Thus, TLV and HMAC support  is optional for any implementation "
> " Type Length Value (TLV) entries contain OPTIONAL information that may
>    be used by the node identified in the Destination Address (DA) of the
>    packet. "
> " The Length field of the TLV is used to skip the TLV while inspecting
>    the SRH in case the node doesn't support or recognize the Type. "
>
> My understanding on SRH can support my assumption.

Tianran,

RFC8200 allows intermediate nodes to ignore TLVs in HBH options, and I did propose allowing intermediate destinations to ignore destination options before the routing header in draft-herbert-ipv6-update-opts.

ZTR> It is true, but this is another story. RFC8200 is new, while RFC2460 has been widely deployed. The industry need time to evolve. I talked about the reality. The new proposal is motivated by the real deployment.

But allowing nodes to ignore TLVs only mitigates the problems of packet loss in the presence of TLVs; the obvious purpose of defining a new TLV is that it _will_ be processed, lest the host sender is just wasting cycles and bandwidth sending bits no one looks at. If all implementations of SRH ignore TLVs then defining the TLV is pointless (AFAIK only Linux and maybe VPP software implementations support SRH TLVs). For the purposes of actually processing a TLV, like alt mark, I still don't see any advantage to putting this in SRH as opposed to Destination options or HBH options.

ZTR> We consider the incremental deployment case, or the deployment with multi-vendors. That means the supportive node could process SRH TLV well, while the non-supportive node could still transit. This is still valuable for operators to narrow down the scope when packet loss happens. This could also encourage the new tech development and deployment. I see this is very useful.

Tom

>
> Best,
> Tianran
>
> -----Original Message-----
> From: spring [mailto:[email-masked]] On Behalf Of Joel M. 
> Halpern
> Sent: Wednesday, November 10, 2021 10:38 AM
> To: Tianran Zhou <[email-masked]>
> Cc: [email-masked]; [email-masked]; 
> [email-masked]
> Subject: Re: [spring] A question for draft-fz-spring-srv6-alt-mark
>
> (Again, speaking as  participant.)
> You seem to be assuming that devices (hard or soft) that support SRH will support this new TLV.  It is not obvious that they will support any SRH TLVs.  And if they do, they clearly will not support a not yet defined TLV.
>
> Yours,
> Joel
>
> On 11/9/2021 9:04 PM, Tianran Zhou wrote:
> > Hi Tom,
> >
> > All you arguments are correct.
> > If a network is built all by supportive devices (support HbH, DoH), there is no doubt that 6man-alt-mk is a sound solution.
> >
> > However, existing network may consist many non-supportive devices.
> > These devices may 1. support SRH, but not HbH and DoH. This is the current situation about most chip vendors.
> > 2. some vendors may not want to support HbH and DoH in near future.
> >
> > Then, how to deploy alt-mk in these network?
> > The way is to bypass those non-supportive nodes without packet drop.
> >
> > This is why SRH TLV based spring-srv6-alt-mark is proposed.
> >
> > Best,
> > Tianran
> >
> > -----Original Message-----
> > From: ipv6 [mailto:[email-masked]] On Behalf Of Tom Herbert
> > Sent: Tuesday, November 9, 2021 11:41 PM
> > To: Joel M. Halpern <[email-masked]>
> > Cc: [email-masked]; [email-masked]; 
> > [email-masked]
> > Subject: Re: A question for draft-fz-spring-srv6-alt-mark
> >
> > On Tue, Nov 9, 2021 at 7:31 AM Joel M. Halpern <[email-masked]> wrote:
> >>
> >> Let me try phrasing the question about the SRH TLV in a different way.
> >> And this is as a participant, not as co-chair.
> >> Assumptions as I understand them:
> >>
> >> 1) The 6man draft requires support of both the HbH and DoH cases
> >> 2) Any node supporting the SRH altMarking can be assumed to also 
> >> support the 6man altMark
> >>
> >> If assumption 2 is accurate, then it seems to me that adding the 
> >> SRH TLV adds complexity to save a few bits without adding any capability.
> >> This strikes me as a bad trade.
> >
> > +1
> >
> > Also, destination and hop-by-hop options have the advantage that they work with any other extension header or protocol. SRH TLVs only work in the narrow use case of SRv6 and don't help router headers that might be defined.
> >
> > Tom
> >
> >>
> >> Yours,
> >> Joel
> >>
> >> On 11/8/2021 2:28 PM, Giuseppe Fioccola wrote:
> >>> Hi Greg,
> >>>
> >>> Yes, with DOH + SRH, the end node of a segment should still 
> >>> conform to RFC8200, based on the discussion in 6MAN.
> >>>
> >>> The proposal to use HBH is also mentioned in draft-ietf-6man-ipv6-alt-mark.
> >>>
> >>> Regards,
> >>>
> >>> Giuseppe
> >>>
> >>> *From:* Greg Mirsky <[email-masked]>
> >>> *Sent:* Monday, November 8, 2021 6:17 PM
> >>> *To:* Giuseppe Fioccola <[email-masked]>
> >>> *Cc:* [email-masked]; [email-masked]; 
> >>> [email-masked]
> >>> *Subject:* Re: A question for draft-fz-spring-srv6-alt-mark
> >>>
> >>> Hi Giuseppe,
> >>>
> >>> thank you for the clarification.
> >>>
> >>> I was considering the DOH+SDH but am not sure if the end node of a 
> >>> segment conforms to the note attributed to DOH in RFC 8200:
> >>>
> >>>      note 3: for options to be processed only by the final destination of
> >>>      the packet.
> >>>
> >>> I recall the discussion in 6man WG but not the final conclusion of it.
> >>>
> >>> My proposal to use HbH EH included the use of the management plane 
> >>> to explicitly enable AltMarking only on segment end-points and 
> >>> keep it disabled on transit nodes.
> >>>
> >>> Regards,
> >>>
> >>> Greg
> >>>
> >>> On Mon, Nov 8, 2021 at 8:50 AM Giuseppe Fioccola 
> >>> <[email-masked] <mailto:[email-masked]>> wrote:
> >>>
> >>>      Hi Greg,
> >>>
> >>>      The use of HbH EH does not fit well in the case of SRH. Indeed, with
> >>>      the AltMark HbH Option, it is possible to monitor every router on
> >>>      the path with feature enabled, so it potentially allows the
> >>>      measurement to every nodes in the path and not only to the nodes
> >>>      that are identities in the SR path.
> >>>
> >>>      While, with the Destination Option preceding a Routing Header, it is
> >>>      possible to apply the measurement to every destination node in the
> >>>      route list. This means that, whenthe AltMark Destination Option
> >>>      precedes the SRH, it allows the measurement for all the nodes that
> >>>      are identities in the SR path.
> >>>
> >>>      The solution with SRH TLV is equivalent to DOH + SRH, but it can be
> >>>      an optimized solution for SRH since it leverages the SRH TLV
> >>>      capability, without adding an additional EH that can be a problem in
> >>>      some cases.
> >>>
> >>>      Regards,
> >>>
> >>>      Giuseppe
> >>>
> >>>      *From:* Greg Mirsky <[email-masked]
> >>>      <mailto:[email-masked]>>
> >>>      *Sent:* Monday, November 8, 2021 2:57 PM
> >>>      *To:* Giuseppe Fioccola <[email-masked]
> >>>      <mailto:[email-masked]>>
> >>>      *Cc:* [email-masked]
> >>>      <mailto:[email-masked]>; [email-masked]
> >>>      <mailto:[email-masked]>; [email-masked] <mailto:[email-masked]>
> >>>      *Subject:* Re: A question for draft-fz-spring-srv6-alt-mark
> >>>
> >>>      Hi Giuseppe,
> >>>
> >>>      thank you for the detailed explanation of what the authors consider
> >>>      as the problem. In the presentation, you've mentioned that the new
> >>>      AltMark SRH TLV allows for better control of which nodes along an SR
> >>>      Policy participate in the measurement. I imagine that the HbH IPv6
> >>>      extension header that includes the AltMark TLV can be used to
> >>>      achieve the same result if only SR nodes are enabled for the AltMark
> >>>      processing. What do you think of using the HbH EH? Am I missing
> >>>      something?
> >>>
> >>>      Regards,
> >>>
> >>>      Greg
> >>>
> >>>      On Mon, Nov 8, 2021 at 1:13 AM Giuseppe Fioccola
> >>>      <[email-masked] <mailto:[email-masked]>>
> >>>      wrote:
> >>>
> >>>      Hi Greg,
> >>>
> >>>      Thank you for your comment.
> >>>
> >>>      It is very good to have your support on this draft.
> >>>
> >>>      draft-ietf-6man-ipv6-alt-mark defines the AltMark DOH. In case of
> >>>      SRH, DOH + SRH can be used to implement the measurement for every
> >>>      node that is an identity in the SR path.
> >>>
> >>>      But, the approach with DOH + SRH requires two extension headers and
> >>>      this can have operational implications.
> >>>
> >>>      The goal of this draft is to find an optimized solution that best
> >>>      suits for SRH. Therefore we propose to use the SRH TLV. If accepted,
> >>>      this document would update draft-ietf-6man-ipv6-alt-mark only for SRv6:
> >>>
> >>>      - in case of SRH there would be a single way to apply AltMark
> >>>      through SRH TLV,
> >>>
> >>>      - while for all the other cases with IPv6 data plane the use of the
> >>>      HbH and DOH is the only choice to carry AltMark data fields.
> >>>
> >>>      Regards,
> >>>
> >>>      Giuseppe
> >>>
> >>>      *From:* Greg Mirsky <[email-masked]
> >>>      <mailto:[email-masked]>>
> >>>      *Sent:* Sunday, November 7, 2021 9:01 PM
> >>>      *To:* [email-masked]
> >>>      <mailto:[email-masked]>; [email-masked]
> >>>      <mailto:[email-masked]>; [email-masked] <mailto:[email-masked]>
> >>>      *Subject:* A question for draft-fz-spring-srv6-alt-mark
> >>>
> >>>      Dear Authors et al.
> >>>
> >>>      thank you for this document. I am supporting and following the work
> >>>      on the Alternate Marking method in various IETF WGs. What do you see
> >>>      as the benefits of defining a new SRH TLV for the Alternate Marking
> >>>      method compared to solutions defined for IPv6 in
> >>>      draft-ietf-6man-ipv6-alt-mark
> >>>      <https://datatracker.ietf.org/doc/draft-ietf-6man-ipv6-alt-mark/>?
> >>>
> >>>      Regards,
> >>>
> >>>      Greg
> >>>
> >>>
> >>> ------------------------------------------------------------------
> >>> -- IETF IPv6 working group mailing list [email-masked] 
> >>> Administrative
> >>> Requests: https://www.ietf.org/mailman/listinfo/ipv6
> >>> ------------------------------------------------------------------
> >>> --
> >>>
> >>
> >> -------------------------------------------------------------------
> >> - IETF IPv6 working group mailing list [email-masked] Administrative 
> >> Requests: https://www.ietf.org/mailman/listinfo/ipv6
> >> -------------------------------------------------------------------
> >> -
> >
> > --------------------------------------------------------------------
> > IETF IPv6 working group mailing list [email-masked] Administrative 
> > Requests: https://www.ietf.org/mailman/listinfo/ipv6
> > --------------------------------------------------------------------
> >
>
> _______________________________________________
> spring mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/spring
>
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------

---

From: Tom Herbert <[email-masked]>
Date: Thu, 11 Nov 2021 09:05:29 -0800

Tianran,

I think you're dancing around the core problem. Hardware
implementations didn't support Hop-by-Hop options because they contain
TLVs which are considered to be hard to process in a high performance
datapath hardware pipeline. RFC2460 did mandate that all intermediate
nodes need to process the HBH options which left hardware vendors with
three choices: 1) process them in a software slow path and adhere to
RFC2460 2) ignore them altogether and violate RFC2460 3) drop the
packet which technically adheres to RFC2460, but obviously kills any
utility of feature. RFC8200 relaxed the requirement for all nodes to
process HBH options and acknowledged that this is reality. From an
application perspective, if the TLVs can't be processed in a "fast
path" it is best to ignore the options.

So the underlying problem is in fact the complexity of processing TLVs
in hardware datapath. Just replicating the same TLV mechanism in more
protocols like SRH does nothing to help solve the problem. Until this
is solved I don't believe we'll ever see TLVs being productively used
in L3 (I suppose this might the anticipated industry evolution to
which you referred). On the other hand if the problem is solved and a
deployable an economical solution is presented that hardware vendors
would adopt, then the problem would be solved for a whole class of use
case (i.e. the same basic TLV construct is used in HBH, DestOpts, SRH,
TCP options, IP options, UDP options, etc.).

If you're interested, I will be outlining the solution to this problem
that we're working on in IPv6/v6ops meeting tomorrow.

Tom

---

From: [email-masked]
Date: Thu, 11 Nov 2021 18:33:46 +0100

Tom,

[...]

> path" it is best to ignore the options.

I mostly agree with your reasoning.
To add some more nuance. The only TLV that existed was Router Altert for MLD, and that was a signal to send the packet to the control plane.
I think the reason HBH isn't implemented in hardware is because there aren't any options in existence. Until quite recently.
And those mainly apply in a limited domain.

If a transit network supported some specific forwarding behavour triggered by the HBH option, it would be highly unlikely that it would allow arbitrary end-users to use that function.

To conclude. HBH hasn't been implemented in hardware because there hasn't been a use case.

Cheers,
Ole

---

From: Haoyu Song <[email-masked]>
Date: Thu, 11 Nov 2021 18:52:51 +0000

Comments inline marked with HS>>

Best,
Haoyu

-----Original Message-----
From: ipv6 <[email-masked]> On Behalf Of Tom Herbert
Sent: Thursday, November 11, 2021 9:05 AM
To: Tianran Zhou <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: Re: [spring] A question for draft-fz-spring-srv6-alt-mark

Tianran,

I think you're dancing around the core problem. Hardware implementations didn't support Hop-by-Hop options because they contain TLVs which are considered to be hard to process in a high performance datapath hardware pipeline. RFC2460 did mandate that all intermediate nodes need to process the HBH options which left hardware vendors with three choices: 1) process them in a software slow path and adhere to
RFC2460 2) ignore them altogether and violate RFC2460 3) drop the packet which technically adheres to RFC2460, but obviously kills any utility of feature. RFC8200 relaxed the requirement for all nodes to process HBH options and acknowledged that this is reality. From an application perspective, if the TLVs can't be processed in a "fast path" it is best to ignore the options.

So the underlying problem is in fact the complexity of processing TLVs in hardware datapath. Just replicating the same TLV mechanism in more protocols like SRH does nothing to help solve the problem. Until this is solved I don't believe we'll ever see TLVs being productively used in L3 (I suppose this might the anticipated industry evolution to which you referred). On the other hand if the problem is solved and a deployable an economical solution is presented that hardware vendors would adopt, then the problem would be solved for a whole class of use case (i.e. the same basic TLV construct is used in HBH, DestOpts, SRH, TCP options, IP options, UDP options, etc.).

HS>> TLVs are not inherently difficult to process in hardware. There are two parts of TLV processing. First is parsing. Yes it would need more clock cycles to parse a TLV than a normal header, but parser is not the performance bottleneck and the overhead is acceptable. The second part is actually performing the function dictated by the TLV. This depends highly on the nature of the function itself. If it's proper for efficient hardware implementation, then there's no problem to support it. So here I think the core issues are what kind of TLV function we should allow in hardware and how we would modify the standard rules to accommodate them in existing extension headers. 

If you're interested, I will be outlining the solution to this problem that we're working on in IPv6/v6ops meeting tomorrow.

Tom

> > >>> I was considering the DOH+SDH but am not sure if the end node of 
> > >>> a segment conforms to the note attributed to DOH in RFC 8200:
> > >>>
> > >>> My proposal to use HbH EH included the use of the management 
> > >>> plane to explicitly enable AltMarking only on segment end-points 
> > >>> and keep it disabled on transit nodes.
> > >>>
> > >>> Regards,
> > >>>
> > >>> Greg
> > >>>
> > >>>      <https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fdatatracker.ietf.org%2Fdoc%2Fdraft-ietf-6man-ipv6-alt-mark%2F&amp;data=04%7C01%7Chaoyu.song%40futurewei.com%7C397aedf2a2d040c0612f08d9a5358eee%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637722471737333496%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&amp;sdata=%2BTX6zZJUosYEDB%2BIPBJuiDu32W5wSKvki3M2SVxiqX0%3D&amp;reserved=0>?
> > >>>
> > >>>      Regards,
> > >>>
> > >>>      Greg
> > >>>
> > >>>
> > >>> Requests: 
> > >>> https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%
> > >>> 2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fipv6&amp;data=04%7C01%7Cha
> > >>> oyu.song%40futurewei.com%7C397aedf2a2d040c0612f08d9a5358eee%7C0f
> > >>> ee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637722471737333496%7CUn
> > >>> known%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6
> > >>> Ik1haWwiLCJXVCI6Mn0%3D%7C3000&amp;sdata=V%2BW%2BlClfp%2BSGaU15lk
> > >>> NYe3UN%2Fyfm4MxzVhg09RvOyiI%3D&amp;reserved=0
> > >> Requests: 
> > >> https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2
> > >> Fwww.ietf.org%2Fmailman%2Flistinfo%2Fipv6&amp;data=04%7C01%7Chaoy
> > >> u.song%40futurewei.com%7C397aedf2a2d040c0612f08d9a5358eee%7C0fee8
> > >> ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637722471737333496%7CUnknow
> > >> n%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1ha
> > >> WwiLCJXVCI6Mn0%3D%7C3000&amp;sdata=V%2BW%2BlClfp%2BSGaU15lkNYe3UN
> > >> %2Fyfm4MxzVhg09RvOyiI%3D&amp;reserved=0
> > > Requests: 
> > > https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2F
> > > www.ietf.org%2Fmailman%2Flistinfo%2Fipv6&amp;data=04%7C01%7Chaoyu.
> > > song%40futurewei.com%7C397aedf2a2d040c0612f08d9a5358eee%7C0fee8ff2
> > > a3b240189c753a1d5591fedc%7C1%7C1%7C637722471737333496%7CUnknown%7C
> > > TWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLC
> > > JXVCI6Mn0%3D%7C3000&amp;sdata=V%2BW%2BlClfp%2BSGaU15lkNYe3UN%2Fyfm
> > > 4MxzVhg09RvOyiI%3D&amp;reserved=0
> > https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fww
> > w.ietf.org%2Fmailman%2Flistinfo%2Fspring&amp;data=04%7C01%7Chaoyu.so
> > ng%40futurewei.com%7C397aedf2a2d040c0612f08d9a5358eee%7C0fee8ff2a3b2
> > 40189c753a1d5591fedc%7C1%7C1%7C637722471737343453%7CUnknown%7CTWFpbG
> > Zsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn
> > 0%3D%7C3000&amp;sdata=CfkmUJeMArNE%2B12mLy43DXUwulDdE2Zj%2BDvEZePrQh
> > I%3D&amp;reserved=0
> >
> > Requests: 
> > https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fww
> > w.ietf.org%2Fmailman%2Flistinfo%2Fipv6&amp;data=04%7C01%7Chaoyu.song
> > %40futurewei.com%7C397aedf2a2d040c0612f08d9a5358eee%7C0fee8ff2a3b240
> > 189c753a1d5591fedc%7C1%7C1%7C637722471737343453%7CUnknown%7CTWFpbGZs
> > b3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%
> > 3D%7C3000&amp;sdata=6vpCFvUyAtCLolarN7ITrdefMaRt8E1g6El6bNBn2Rw%3D&a
> > mp;reserved=0

--------------------------------------------------------------------
IETF IPv6 working group mailing list
[email-masked]
Administrative Requests: https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fipv6&amp;data=04%7C01%7Chaoyu.song%40futurewei.com%7C397aedf2a2d040c0612f08d9a5358eee%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C1%7C637722471737343453%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C3000&amp;sdata=6vpCFvUyAtCLolarN7ITrdefMaRt8E1g6El6bNBn2Rw%3D&amp;reserved=0
--------------------------------------------------------------------

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 11 Nov 2021 18:58:10 +0000

+1 .

To Ole that without a good use case in a limited domain it’s hard to expect implementation.

To the point that the HbH must remain simple to operate and very short, same spirit as already demonstrated with SRH.

We’re in a weird situation with arbitrary limits in vendor silicon because the IETF failed to give clear directions on EH sizes.

It would be neat to provide a roadmap of how long the minimum EH size to parse should be so the IETF can design things that can be later implemented by the vendors.

Regards,

Pascal

Le 11 nov. 2021 à 18:34, [email-masked] a écrit :

Tom,

[...]

Cheers,
Ole

---

From: Tom Herbert <[email-masked]>
Date: Thu, 11 Nov 2021 11:18:02 -0800

Pascal,

Comments in line.

> To Ole that without a good use case in a limited domain it’s hard to expect implementation.
Unfortunately, TLVs weren't interesting enough when the protocol was
defined so now we have a lot of deployed hardware that couldn't
support them even if they wanted. There are two things that give me
hope for the future in that regard: 1) The emergence of programmable
hardware datapaths may eventually limit the need for hardware swap out
everytime someone wants to support a new protocol 2) TCP has always
has TLVs as a core part of the protocol, as hardware implementation
move up the stack they are going to need to deal with TLVs (like it
someone wanted to build a high performance NVMe/TCP stack in
hardware).

> It would be neat to provide a roadmap of how long the minimum EH size to parse should be so the IETF can design things that can be later implemented by the vendors.

That is precisely the intent of
https://tools.ietf.org/id/draft-herbert-6man-eh-limits-00.txt :-)

Tom

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Thu, 11 Nov 2021 21:32:27 +0000

Hi Tom,

Yes, to all.

My sentence was the conscious part of my +1 above in support of your work. 

The values, whatever they are, must be adapted to dev cycles (over multiple years) and could be defined with a roadmap to increase over time.

Regards,

Pascal

> Le 11 nov. 2021 à 20:19, Tom Herbert <[email-masked]> a écrit :
> 
> Pascal,
> 
> Comments in line.
>

---

From: Tianran Zhou <[email-masked]>
Date: Fri, 12 Nov 2021 08:55:36 +0000

Hi Tom,

Firstly, the proposed solution follows the same logic as RFC8200, as in your text. So I do not see any problem. We just find another away to "ignore the options".
" RFC8200 relaxed the requirement for all nodes to process HBH options and acknowledged that this is reality. From an application perspective, if the TLVs can't be processed in a "fast path" it is best to ignore the options."

Secondly, I agree with the complexity of processing TLV. But we have already implemented the function with line rate. So the "core problem" from my perspective is how to deploy it.

We are always on the way to performance optimization. I've read your draft, and your solution is very interesting.

Best,
Tianran

-----Original Message-----
From: Tom Herbert [mailto:[email-masked]] 
Sent: Friday, November 12, 2021 1:05 AM
To: Tianran Zhou <[email-masked]>
Cc: Joel M. Halpern <[email-masked]>; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [spring] A question for draft-fz-spring-srv6-alt-mark

On Wed, Nov 10, 2021 at 10:48 PM Tianran Zhou <[email-masked]> wrote:
> 抄送: Joel M. Halpern <[email-masked]>; 
> [email-masked]; [email-masked]; [email-masked]

Tianran,

Tom

---

From: Ron Bonica <[email-masked]>
Date: Mon, 15 Nov 2021 22:20:29 +0000

Folks,

The  SRH TLV for Alternate Marking isn't needed because its meaning is identical to the AltMark Option when it appears in a Destination Options Header that precedes the SRH. 

Arguments regarding the HBH are orthogonal to this issue. The HBH is processed at every node along a packet's deliver path, while the Destination Options header that precedes the SRH is processed " by the first destination that appears in the IPv6 Destination Address field plus subsequent destinations listed in the Routing header.

Arguments regarding whether a complete IPv6 implementation must support the Destination Options header have already been settled by RFC 8200.

Arguments about whether it is easier to parse two smaller extension headers or one larger extension headers are not appropriate in the IETF, because they are platform dependent.

                                                                                                                  Ron

Juniper Business Use Only

-----Original Message-----
From: spring <[email-masked]> On Behalf Of Tianran Zhou
Sent: Friday, November 12, 2021 3:56 AM
To: Tom Herbert <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]
Subject: Re: [spring] A question for draft-fz-spring-srv6-alt-mark

[External Email. Be cautious of content]

Hi Tom,

Best,
Tianran

-----Original Message-----
From: Tom Herbert [mailto:[email-masked]]
Sent: Friday, November 12, 2021 1:05 AM
To: Tianran Zhou <[email-masked]>
Cc: Joel M. Halpern <[email-masked]>; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [spring] A question for draft-fz-spring-srv6-alt-mark

Tianran,

Tom

> > >>>      <https://urldefense.com/v3/__https://datatracker.ietf.org/doc/draft-ietf-6man-ipv6-alt-mark/__;!!NEt6yMaO-gk!Rer99s0DO7Ys6kR2kNbYfO5WFUh7DlH4ouzWfIp_chK7mPTLWcpo221rpmep31F9$ >?
> > >>>
> > >>>      Regards,
> > >>>
> > >>>      Greg
> > >>>
> > >>>
> > >>> https://urldefense.com/v3/__https://www.ietf.org/mailman/listinf
> > >>> o/ipv6__;!!NEt6yMaO-gk!Rer99s0DO7Ys6kR2kNbYfO5WFUh7DlH4ouzWfIp_c
> > >>> hK7mPTLWcpo221rprIfvSmZ$
> > >> https://urldefense.com/v3/__https://www.ietf.org/mailman/listinfo
> > >> /ipv6__;!!NEt6yMaO-gk!Rer99s0DO7Ys6kR2kNbYfO5WFUh7DlH4ouzWfIp_chK
> > >> 7mPTLWcpo221rprIfvSmZ$
> > > https://urldefense.com/v3/__https://www.ietf.org/mailman/listinfo/
> > > ipv6__;!!NEt6yMaO-gk!Rer99s0DO7Ys6kR2kNbYfO5WFUh7DlH4ouzWfIp_chK7m
> > > PTLWcpo221rprIfvSmZ$
> > https://urldefense.com/v3/__https://www.ietf.org/mailman/listinfo/sp
> > ring__;!!NEt6yMaO-gk!Rer99s0DO7Ys6kR2kNbYfO5WFUh7DlH4ouzWfIp_chK7mPT
> > LWcpo221rpu4mP70S$
> >
> > https://urldefense.com/v3/__https://www.ietf.org/mailman/listinfo/ip
> > v6__;!!NEt6yMaO-gk!Rer99s0DO7Ys6kR2kNbYfO5WFUh7DlH4ouzWfIp_chK7mPTLW
> > cpo221rprIfvSmZ$
_______________________________________________
spring mailing list
[email-masked]
https://urldefense.com/v3/__https://www.ietf.org/mailman/listinfo/spring__;!!NEt6yMaO-gk!Rer99s0DO7Ys6kR2kNbYfO5WFUh7DlH4ouzWfIp_chK7mPTLWcpo221rpu4mP70S$